<?php
/**
 * iPay Payment Gateway Plugin for J2Store Component
 * PHP version 5.6+
 * @author SlashDotLabs
 * @copyright 2010-2018 https://ipayafrica.com
 * @version 1.0.0
 * @link https://ipayafrica.com
 */
defined('_JEXEC') or die('Restricted access');

require_once (JPATH_ADMINISTRATOR.'/components/com_j2store/library/plugins/payment.php');
require_once (JPATH_ADMINISTRATOR.'/components/com_j2store/helpers/j2store.php');

class plgJ2StorePayment_ipay extends J2StorePaymentPlugin
{
    /**
     * @var $_element  string  Should always correspond with the plugin's filename,
     *                         forcing it to be unique
     */
    public $_element   = 'payment_ipay';
    private $apikey = '';
    private $callBackUrl = '';
    private $currency = '';

    public function __construct(& $subject, $config)
    {
        parent::__construct($subject, $config);
        $this->loadLanguage( '', JPATH_ADMINISTRATOR );
        $this->apikey = trim($this->params->get('api_key'));
        $this->callBackUrl = JUri::root().'/index.php?option=com_j2store&view=checkout&task=confirmPayment&orderpayment_type=payment_ipay&paction=callback';
        $this->currrency = J2Store::currency();
    }

    public function _renderForm( $data )
    {
        $vars = new JObject();
        $html = $this->_getLayout('form');
        return $html;
    }

    public function _prePayment($data)
    {

        $app            = JFactory::getApplication();
        $currency       = J2Store::currency();
        F0FTable::addIncludePath(JPATH_ADMINISTRATOR.'/components/com_j2store/tables');
        $order          = F0FTable::getInstance('Order', 'J2StoreTable');
        $order->load($data['orderpayment_id']);
        $orderinfo      = $order->getOrderInformation();
        $currency_values= $this->getCurrency($order);

        $live       = $this->params->get('sandbox');
        $mpesa      = $this->params->get('mpesa');
        $airtel     = $this->params->get('airtel');
        $equity     = $this->params->get('equity');
        $debitcard  = $this->params->get('debitcard');
        $creditcard = $this->params->get('creditcard');
        $pesalink   = $this->params->get('pesalink');
        $live       = $this->params->get('sandbox');
        $mm         = 1; 
        $mb         = 1; 
        $dc         = 1; 
        $cc         = 1; 
        $mer        = $this->params->get('mer_name'); 
        $oid        = $data['order_id']; 
        $ttl        = $data['orderpayment_amount'];
        $tel        = $orderinfo->billing_phone_1; 
        $eml        = $order->user_email; 
        $vid        = $this->params->get('vendor_id'); 
        $curr       = $currency_values['currency_code'];
        $p1         = "";
        $p2         = "";
        $p3         = "";
        $p4         = "";
        $cbk        = $this->callBackUrl;
        $cst        = 1;
        $crl        = 0; 
        $hsh        = $this->params->get('hash_key');
        $inv        = $oid;
        $bonga      = "1";
        $vooma      = "1";
        $channel    = "J2Store";

        $base_url = "https://payments.ipayafrica.com/v3/ke?live=";
        switch($this->params->get('mer_country')){
            case "Kenya":
                $base_url = "https://payments.ipayafrica.com/v3/ke?live=";
                break;
            case "Tanzania":
                $base_url = "https://payments.elipa.co.tz/v3/tz?live=";
                break;
            case "Uganda":
                $base_url = "https://payments.elipa.co.ug/v3/ug?live=";
                break;
            case "Togo":
                $base_url = "https://payments.elipa.tg/v1/v3/index.php/togo?live=";
                break;
            default:     
                $base_url = "https://payments.ipayafrica.com/v3/ke?live=";
                break;
        }

        $datastring = $live.$oid.$inv.$ttl.$tel.$eml.$vid.$curr.$p1.$p2.$p3.$p4.$cbk.$cst.$crl;
        $hsh        = hash_hmac('sha1', $datastring, $hsh);
        $cbk        = urlencode($cbk);//url encode
        $theUrl     = $base_url."$live&oid=$oid&inv=$inv&ttl=$ttl&tel=$tel&eml=$eml&vid=$vid&curr=$curr&p1=$p1&p2=$p2&p3=$p3&p4=$p4&crl=$crl&cbk=$cbk&cst=$cst&hsh=$hsh&bonga=$bonga&vooma=$vooma&channel=$channel";

        $vars = new StdClass();
        $vars->onbeforepayment_text = JText::_("M-Pesa, Airtel Money, Eazzypay, Lipa na Bonga Points, VISA/Mastercard, Pesalink");
        $vars->redirect = $theUrl;

        $html = $this->_getLayout('prepayment', $vars);
        return $html;
    }

    public function _postPayment($data)
    {
        $vars = new JObject();
        //get order id
        $orderId = $data['order_id'];
        // get instatnce of j2store table
        F0FTable::addIncludePath(JPATH_ADMINISTRATOR.'/components/com_j2store/tables');
        $order = F0FTable::getInstance('Order', 'J2StoreTable')->getClone();
        $order->load(array('order_id' => $orderId));

        $trans_id   = $_GET['id'];

        if($order->load(array('order_id' => $orderId))){

            if(isset($_GET["txncd"])){

                $val           = $this->params->get('vendor_id'); // the vendor ID
                $val1          = $_GET['id'];
                $val2          = $_GET['ivm'];
                $val3          = $_GET['qwh'];
                $val4          = $_GET['afd'];
                $val5          = $_GET['poi'];
                $val6          = $_GET['uyt'];
                $val7          = $_GET['ifd'];


                $ipnurl        = "https://www.ipayafrica.com/ipn/?vendor=".$val."&id=".$val1."&ivm=".$val2."&qwh=".$val3."&afd=".$val4."&poi=".$val5."&uyt=".$val6."&ifd=".$val7;

                if($val == "demo"){
                    $status = "aei7p7yrx4ae34";
                }else{
                    $fp            = fopen($ipnurl, "rb");
                    $status        = stream_get_contents($fp, -1, -1);//$_GET['status'];
                    fclose($fp);
                }
                

                switch ($status) {
                    case 'aei7p7yrx4ae34':
                        //success
                        $order->payment_complete();
                        $order->empty_cart();
                        $message = JText::_("Payment Successful"). "\n\n";
                        $message .= JText::_("Transaction ID") . " : ". $trans_id;
                        break;

                    case 'eq3i7p5yt7645e':
                        //overpaid
                        $message = JText::_("Transaction Overpaid"). "\n\n";
                        $message .= JText::_("Transaction ID") . " : ". $trans_id;
                        break;

                    case 'fe2707etr5s4wq':
                        //Failed
                        $message = JText::_("Transaction Failed"). "\n\n";
                        $message .= JText::_("Transaction ID") . " : ". $trans_id;
                        break;

                    case 'dtfi4p7yty45wq':
                        //underpaid
                        $message = JText::_("Transaction Underpaid"). "\n\n";
                        $message .= JText::_("Transaction ID") . " : ". $trans_id;
                        break;

                    case 'cr5i3pgy9867e1':
                        //used
                        $message = JText::_("Transaction Used"). "\n\n";
                        $message .= JText::_("Transaction ID") . " : ". $trans_id;
                        break;

                    case 'bdi6p2yy76etrs':
                        //pending
                        $message = JText::_("Transaction Failed"). "\n\n";
                        $message .= JText::_("Transaction ID") . " : ". $trans_id;
                        break;
                    
                    default:
                        $message = JText::_("An error has occured. Kindly contact the site's admin for further "). "\n\n";
                        $message .= JText::_("Transaction ID") . " : ". $trans_id;
                        break;
                }
                $vars->message = $message;
                $html = $this->_getLayout('postpayment', $vars);
                return $html;
            }
            else{ 

                $message   = JText::_("Unable to get the Order Details from iPay. Contact the site's admin")."\n\n";
                $message   .= JText::_("Transaction ID") . " : ". $trans_id;
                $vars->message = $message;
                $html = $this->_getLayout('postpayment', $vars);
                return $html;
            }

            
        }
        else{

            $message    = JText::_("An error occured. Kindly contact the site's admin")."\n\n";
            $message    .= JText::_("Transaction ID") . " : ". $trans_id;
            $vars->message = $message;
            $html = $this->_getLayout('postpayment', $vars);
            return $html;
        }
    }

}